// get all calculated value into the histogram
using namespace std;
#include<TROOT.h>
#include<iostream>
#include<heplist.h>
#include<getevkin.h> 
// CLHEP
#include "CLHEP/config/CLHEP.h"
#include "CLHEP/Vector/LorentzVector.h"
#include "CLHEP/Vector/Boost.h"
#include "CLHEP/Vector/Rotation.h"


extern heplist hep;      // get particles after the cuts


Int_t  user_afill( char * type, char * nnn, Double_t* getval, Long_t nc1=-1, Long_t nc2=-1);

// get jet varibales for LHC 

// ----------------------- Fill stable hadrons 
Int_t  user_afill( char * type, char * nnn, double* getval, long nc1, long nc2) {

// to access information to fill histograms 
// Input:
// type="particle" - get varibales for separate particles or events
// type="jet"      - get informations on jets only
// nnn             - name of the histogram (should be given also in user-name.txt 
//                  to make such calculationas available)  
// nc1,nc2  - No of current particle 1 (single-particle density) and particle 2 (for 2-particle density)
//            if not filled - assumes -1 
//
// Output:
// getval - value to fill histogram

// as example, see system files 
//   $RUNMC/main/src/afill.cpp as example
//   $RUNMC/main/sys/system-histo.txt 

   extern getevkincommon getevkin_ ; // To access the external COMMON


   *getval = -99999;


// below are example copied from $RUNMC/main/src/afill.cpp

// fill first varibles charcterising events ------------------------
   if (nc1==-1 && nc2==-1) {
// N(tot)
   if (strcmp(nnn,"N(tot)") == 0)  {*getval=hep.PP.size();}
// total bnumber of jets
   else if (strcmp(nnn,"N(jets)") == 0)  {*getval=hep.PJ.size();}
// variables taken from PYTHIA6.1
// see $RUNMC/main/mcarlo/pythia-62/RUNMC-pythia6.f and the RUNMC manual
// how to get paramaters 
// Q2
   else if (strcmp(nnn,"Q2pp") == 0)  {*getval=getevkin_.rUSER[0];}
// x1 
   else if (strcmp(nnn,"x1(hard)") == 0)  {*getval=getevkin_.rUSER[1];}
// x2 
   else if (strcmp(nnn,"x2(hard)") == 0)  {*getval=getevkin_.rUSER[2];}
// Feynman 
   else if (strcmp(nnn,"xFeynman") == 0)  {*getval=getevkin_.rUSER[1]-getevkin_.rUSER[2];}
// Feynman
   else if (strcmp(nnn,"x(average)") == 0)  {*getval=0.5*(getevkin_.rUSER[1]+getevkin_.rUSER[2]);}

// end of the even shape ------------------------------------------
// do not do anything
  else {
       return 1;
   };

   }; // end filling event varibales


// fill first varibles charcterising single particles ------------------------
     if (nc1 != -1 && nc2==-1 && strcmp(type,"particle") == 0) {
// put calculations 
     if (strcmp(nnn,"Put_here_some_title ") == 0)  {
     } else {
// do not do anything
     return 1; };

   };
 
 
// fill first varibles charcterising 2-particle density (invarinat mass etc) ---------------
   if (nc1 != -1 && nc2 !=-1 && strcmp(type,"particle") == 0) {
// put calculations 
     if (strcmp(nnn,"Put_here_some_title ") == 0)  {
     } else {
// do not do anything
     return 1; };
   }; // end 2-particle densities

// fill jet varibales (1-particle densities)
   if (nc1 != -1 && nc2 ==-1 && strcmp(type,"jet") == 0) {
   if      (strcmp(nnn,"Px(jets)") == 0)  { *getval=hep.PJ[nc1].p.px();}
   else if (strcmp(nnn,"Py(jets)") == 0)  { *getval=hep.PJ[nc1].p.py();}
   else if (strcmp(nnn,"Pz(jets)") == 0)  { *getval=hep.PJ[nc1].p.pz();}
   else if (strcmp(nnn,"E(jets)")  == 0)  { *getval=hep.PJ[nc1].p.e();}
   else if (strcmp(nnn,"ET(jets)")  == 0) { *getval=hep.PJ[nc1].p.perp(); }
   else if (strcmp(nnn,"Phi(jets)")  == 0)  { *getval=hep.PJ[nc1].p.phi(); }
   else if (strcmp(nnn,"Theta(jets)")  == 0) { *getval=hep.PJ[nc1].p.theta(); }
   else if (strcmp(nnn,"Eta(jets)")  == 0)   { *getval=hep.PJ[nc1].p.pseudoRapidity(); }
   else {
       return 1;
   };
   }; 

// fill jet varibales (2-particle densities i.e M12)
   if (nc1 != -1 && nc2 !=-1 && strcmp(type,"jet") == 0) {
    if (strcmp(nnn,"Put_here_some_title ") == 0)  {
    } else {
       return 1;
   };
   };


 
      return 0;
}
